<?php

namespace app\controllers\mikrotik\capsman;

use yii\helpers\Url;
use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\filters\VerbFilter;
use app\models\mikrotik\MikrotikSideMenu;
use yii\data\ArrayDataProvider;
use app\models\mikrotik\capsman\Accesslist;

class AccesslistController extends Controller {

    public function behaviors() {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'except' => ['index'],
                'rules' => [
                    [
                        'actions' => ['create'],
                        'allow' => true,
                        'roles' => ['mikrotik_capsmanCreateAccesslist'],
                    ],
                    [
                        'actions' => ['delete'],
                        'allow' => true,
                        'roles' => ['mikrotik_capsmanDeleteAccesslist'],
                    ],
                    [
                        'actions' => ['disable'],
                        'allow' => true,
                        'roles' => ['mikrotik_capsmanDisableAccesslist'],
                    ],
                    [
                        'actions' => ['enable'],
                        'allow' => true,
                        'roles' => ['mikrotik_capsmanEnableAccesslist'],
                    ], [
                        'actions' => ['update'],
                        'allow' => true,
                        'roles' => ['mikrotik_capsmanUpdateAccesslist'],
                    ],
                    [
                        'actions' => [],
                        'allow' => true,
                        'roles' => ['admin'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    public function actions() {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

   
    public function actionUpdate() {
        $id = Yii::$app->request->get('id');
        $menu = new MikrotikSideMenu();
        $model = new Accesslist();

        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            $c = $model->update($id);
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
            }
        } else {
            $model->get($id);
        }

        return $this->render('/mikrotik/capsman/accesslist', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'update',
                    'interfaces' => $model->getInterfaces(),
        ]);
    }

    public function actionCreate() {
        $menu = new MikrotikSideMenu();
        $model = new Accesslist();

        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            $c = $model->create();
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
            }
        }

        return $this->render('/mikrotik/capsman/accesslist', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'create',
                    'interfaces' => $model->getInterfaces(),
        ]);
    }

    public function actionDisable() {
        $id = Yii::$app->request->get('id');
        $model = new Accesslist();
        $model->disable($id);
        return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
    }

    public function actionDelete() {
        $id = Yii::$app->request->get('id');
        $model = new Accesslist();
        $model->delete($id);
        return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
    }

    public function actionEnable() {
        $id = Yii::$app->request->get('id');
        $model = new Accesslist();
        $model->enable($id);
        return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
    }

    public function actionReset() {
        $model = new Accesslist();
        $model->reset();
        return $this->redirect(Url::toRoute('mikrotik/capsman/capsman/index'));
    }

}
